package ro.ubbcluj.cs.restapiserver.controller;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import ro.ubbcluj.cs.restapiserver.model.Student;
import ro.ubbcluj.cs.restapiserver.repository.StudentRepository;

@RestController
@RequestMapping("/student")
public class ResourceController {
    @Autowired // This means to get the bean called studentRepository
    // Which is auto-generated by Spring, we will use it to handle the data
    private StudentRepository studentRepository;

    @PostMapping(path="/add") // POST request
    public String addNewStudent (@RequestParam String nume,
                                 @RequestParam String specializare, @RequestParam String grupa) {

        Student s = new Student();
        s.setNume(nume);
        s.setSpecializare(specializare);
        s.setGrupa(grupa);
        studentRepository.save(s);
        return "Saved";
    }

    @PutMapping(path="/update") // PUT request
    public String updateStudent(@RequestBody Student student) {
        studentRepository.save(student);
        return "Updated";
    }

    @DeleteMapping(path="/delete") // DELETE request
    public String deleteStudent(@RequestParam Integer id) {
        studentRepository.deleteById(id);
        return "Deleted";
    }


    @GetMapping(path="/all") // GET request
    public Iterable<Student> getAllStudents() {
        return studentRepository.findAll();
    }


}
